 function dq = myfun(t,q)
 dq = zeros(48,1);
 global r a b h mp mb ma g dinv_J
%% Inverse kinematics
px = -0.1*sin(pi*t);
py = 0.1*cos(pi*t); 
pz = 0.29-0.05*cos((pi*t)/2);
pd = [px py pz].';

dpx = -0.1*pi*cos(pi*t);
dpy = -0.1*pi*sin(pi*t);
dpz = 0.025*pi*sin(pi*t/2);
pd_dot = [dpx dpy dpz].';

d2px = 0.1*pi^2*sin(pi*t);
d2py = -0.1*pi^2*cos(pi*t);
d2pz = (0.025/2)*pi^2*cos(pi*t/2);
pd_2dot = [d2px d2py d2pz].';

phi = [0 pi/2 pi];

   
    R1 = [cos(phi(1)) sin(phi(1)) 0;-sin(phi(1)) cos(phi(1)) 0;0 0 1];
    R2 = [cos(phi(2)) sin(phi(2)) 0;-sin(phi(2)) cos(phi(2)) 0;0 0 1];
    R3 = [cos(phi(3)) sin(phi(3)) 0;-sin(phi(3)) cos(phi(3)) 0;0 0 1];


    c1 = R1*pd+[h-r 0 0].';
    c2 = R2*pd+[h-r 0 0].';
    c3 = R3*pd+[h-r 0 0].';

        q31 = acos(c1(2)/b);
        q32 = acos(c2(2)/b);
        q33 = acos(c3(2)/b);
        
   k1 = (c1(1)^2+c1(2)^2+c1(3)^2-(a^2+b^2))/(2*a*b*sin(q31));
   k2 = (c2(1)^2+c2(2)^2+c2(3)^2-(a^2+b^2))/(2*a*b*sin(q32));
   k3 = (c3(1)^2+c3(2)^2+c3(3)^2-(a^2+b^2))/(2*a*b*sin(q33));
        q21 = acos(k1);
        q22 = acos(k2);
        q23 = acos(k3);


        g11 = a+b*cos(q21)*sin(q31);g12 = a+b*cos(q22)*sin(q32);g13 = a+b*cos(q23)*sin(q33);
        g21 = b*sin(q21)*sin(q31);g22 = b*sin(q22).*sin(q32);g23 = b*sin(q23)*sin(q33);
        q11 = atan2(-g21*c1(1)+g11*c1(3),g11*c1(1)+g21*c1(3));
        q12 = atan2(-g22*c2(1)+g12*c2(3),g12*c2(1)+g22*c2(3));
        q13 = atan2(-g23*c3(1)+g13*c3(3),g13*c3(1)+g23*c3(3));
%% Jacobian Matrix Generation-desired

j1x = b*(cos(q11+q21)*sin(q31)*cos(phi(1))-cos(q31)*sin(phi(1)));
j2x = b*(cos(q12+q22)*sin(q32)*cos(phi(2))-cos(q32)*sin(phi(2)));
j3x = b*(cos(q13+q23)*sin(q33)*cos(phi(3))-cos(q33)*sin(phi(3)));

j1y = b*(cos(q11+q21)*sin(q31)*sin(phi(1))+cos(q31)*cos(phi(1)));
j2y = b*(cos(q12+q22)*sin(q32)*sin(phi(2))+cos(q32)*cos(phi(2)));
j3y = b*(cos(q13+q23)*sin(q33)*sin(phi(3))+cos(q33)*cos(phi(3)));

j1z = b*sin(q11+q21)*sin(q31);
j2z = b*sin(q12+q22)*sin(q32);
j3z = b*sin(q13+q23)*sin(q33);


        jx = [j1x j1y j1z;j2x j2y j2z;j3x j3y j3z];
        jq = a*b*(diag([sin(q21)*sin(q31),sin(q22)*sin(q32),sin(q23)*sin(q33)]));
        J_d = jq\jx;
        qd_dot = J_d*pd_dot; %dq1_13
     
%% qd_dot dq2_13,dq3_13

        pd_dot1 = R1*pd_dot;
        pd_dot2 = R2*pd_dot;
        pd_dot3 = R3*pd_dot;
    
dq31 = -pd_dot1(2)/(b*sin(q31)); %q31_dot-desired
dq32 = -pd_dot2(2)/(b*sin(q32)); %q32_dot-desired
dq33 = -pd_dot3(2)/(b*sin(q33)); %q33_dot-desired
dq21 = (-pd_dot1(1)*cos(q11)-pd_dot1(3)*sin(q11)+b*cos(q21)*cos(q31)*dq31)/(b*sin(q21)*sin(q31))-qd_dot(1);%q21_dot-desired
dq22 = (-pd_dot2(1)*cos(q12)-pd_dot2(3)*sin(q12)+b*cos(q22)*cos(q32)*dq32)/(b*sin(q22)*sin(q32))-qd_dot(2);%q22_dot-desired
dq23 = (-pd_dot3(1)*cos(q13)-pd_dot3(3)*sin(q13)+b*cos(q23)*cos(q33)*dq33)/(b*sin(q23)*sin(q33))-qd_dot(3);%q23_dot-desired
%% qd_2dot
 dj1x = b*cos(phi(1))*(-(qd_dot(1)+dq21)*sin(q11+q21)*sin(q31)+dq31*cos(q11+q21)*cos(q31))+b*sin(phi(1))*dq31*sin(q31);
 dj2x = b*cos(phi(2))*(-(qd_dot(2)+dq22)*sin(q12+q22)*sin(q32)+dq32*cos(q12+q22)*cos(q32))+b*sin(phi(2))*dq32*sin(q32);
 dj3x = b*cos(phi(3))*(-(qd_dot(3)+dq23)*sin(q13+q23)*sin(q33)+dq33*cos(q13+q23)*cos(q33))+b*sin(phi(3))*dq33*sin(q33);
 
 dj1y = b*sin(phi(1))*(-(qd_dot(1)+dq21)*sin(q11+q21)*sin(q31)+dq31*cos(q11+q21)*cos(q31))-b*cos(phi(1))*dq31*sin(q31);
 dj2y = b*sin(phi(2))*(-(qd_dot(2)+dq22)*sin(q12+q22)*sin(q32)+dq32*cos(q12+q22)*cos(q32))-b*cos(phi(2))*dq32*sin(q32);
 dj3y = b*sin(phi(3))*(-(qd_dot(3)+dq23)*sin(q13+q23)*sin(q33)+dq33*cos(q13+q23)*cos(q33))-b*cos(phi(3))*dq33*sin(q33);
 
 dj1z = b*((qd_dot(1)+dq21)*cos(q11+q21)*sin(q31)+dq31*sin(q11+q21)*cos(q31));
 dj2z = b*((qd_dot(2)+dq22)*cos(q12+q22)*sin(q32)+dq32*sin(q12+q22)*cos(q32));
 dj3z = b*((qd_dot(3)+dq23)*cos(q13+q23)*sin(q33)+dq33*sin(q13+q23)*cos(q33));
 
        djx = [dj1x dj1y dj1z;dj2x dj2y dj2z;dj3x dj3y dj3z];
        djq = a*b*diag([dq21*cos(q21)*sin(q31)+dq31*sin(q21)*cos(q31),...
            dq22*cos(q22)*sin(q32)+dq32*sin(q22)*cos(q32),...
            dq23*cos(q23)*sin(q33)+dq33*sin(q23)*cos(q33)]);   
   
        qd_2dot = jq\(djx*pd_dot+jx*pd_2dot-djq*qd_dot); %% qd_2dot 

%% Forward kinematics-position & velocities
%position
k11 = -(r-h+a*cos(q(7)));k12 = 0*ones(numel(t),1);k13 = -a*sin(q(7));
k21 = 0*ones(numel(t),1);k22 = -(r-h+a*cos(q(8)));k23 = -a*sin(q(8));
k31 = (r-h+a*cos(q(9)));k32 = 0*ones(numel(t),1);k33 = -a*sin(q(9));

a1 = 2*(k11-k21);a2 = 2*(k11-k31);
b1 = 2*(k12-k22);b2 = 2*(k12-k32);
c1 = 2*(k13-k23);c2 = 2*(k13-k33);
d1 = (k21^2+k22^2+k23^2)-(k11^2+k12^2+k13^2);
d2 = (k31^2+k32^2+k33^2)-(k11^2+k12^2+k13^2);

D = a1*b2-a2*b1;
f1 = (b2*d1-b1*d2)/D;f2 = (a1*d2-a2*d1)/D ;
fx = (b1*c2-b2*c1)/D;fy = (a2*c1-a1*c2)/D;
f11 = f1+k31;f22 = f2+k32;

A = 1+fx^2+fy^2;
B = 2*((fx*f1+fx*k31+fy*f2+fy*k32+k33));
C = f11^2+f22^2+k33^2-b^2;

    z_r = (-B+sqrt(B^2-4*A*C))/(2*A);
    x_r = f1+fx.*z_r;
    y_r = f2+fy.*z_r;
    p = [x_r y_r z_r].';

%velocities
dk11 = -(-a*q(10)*sin(q(7)));dk12 = 0*ones(numel(t),1);dk13 = -a*q(10)*cos(q(7));
dk21 =  0*ones(numel(t),1);dk22 = -(-a*q(11)*sin(q(8)));dk23 = -a*q(11)*cos(q(8));
dk31 =  (-a*q(12)*sin(q(9)));dk32 = 0*ones(numel(t),1);dk33 = -a*q(12)*cos(q(9));

da1 = 2*(dk11-dk21);da2 = 2*(dk11-dk31);
db1 = 2*(dk12-dk22);db2 = 2*(dk12-dk32);
dc1 = 2*(dk13-dk23);dc2 = 2*(dk13-dk33);
dd1 = (2*k21*dk21+2*k22*dk22+2*k23*dk23)-(2*k11*dk11+2*k12*dk12+2*k13*dk13);
dd2 = (2*k31*dk31+2*k32*dk32+2*k33*dk33)-(2*k11*dk11+2*k12*dk12+2*k13*dk13);

dD = da1*b2+a1*db2-da2*b1-a2*db1;
df1 = ((db2*d1+b2*dd1-db1*d2-b1*dd2)*D-(b2*d1-b1*d2)*dD)/D^2;df2 = ((da1*d2+a1*dd2-da2*d1-a2*dd1)*D-(a1*d2-a2*d1)*dD)/D^2 ;
dfx = ((db1*c2+b1*dc2-db2*c1-b2*dc1)*D-(b1*c2-b2*c1)*dD)/D^2;dfy = ((da2*c1+a2*dc1-da1*c2-a1*dc2)*D-(a2*c1-a1*c2)*dD)/D^2;
df11 = df1+dk31;df22 = df2+dk32;

dA = 2*fx*dfx+2*fy*dfy;
dB = 2*((dfx*f1+fx*df1+dfx*k31+fx*dk31+dfy*f2+fy*df2+dfy*k32+fy*dk32+dk33));
dC = 2*f11*df11+2*f22*df22+2*k33*dk33;

    dz_r = ((-dB+(2*B*dB-4*(dA*C+A*dC))/(2*sqrt(B^2-4*A*C)))*2*A-2*dA*(-B+sqrt(B^2-4*A*C)))/(4*A^2);
    dx_r = df1+dfx*z_r+fx*dz_r;
    dy_r = df2+dfy*z_r+fy*dz_r;
           
            
    p_dot1 = R1*[dx_r dy_r dz_r].';
    p_dot2 = R2*[dx_r dy_r dz_r].';
    p_dot3 = R3*[dx_r dy_r dz_r].';
         
%% Jacobian Matrix Generation-real

j1x = b*(cos(q(7)+q(25))*sin(q(22))*cos(phi(1))-cos(q(22))*sin(phi(1)));
j2x = b*(cos(q(8)+q(26))*sin(q(23))*cos(phi(2))-cos(q(23))*sin(phi(2)));
j3x = b*(cos(q(9)+q(27))*sin(q(24))*cos(phi(3))-cos(q(24))*sin(phi(3)));

j1y = b*(cos(q(7)+q(25))*sin(q(22))*sin(phi(1))+cos(q(22))*cos(phi(1)));
j2y = b*(cos(q(8)+q(26))*sin(q(23))*sin(phi(2))+cos(q(23))*cos(phi(2)));
j3y = b*(cos(q(9)+q(27))*sin(q(24))*sin(phi(3))+cos(q(24))*cos(phi(3)));

j1z = b*sin(q(7)+q(25))*sin(q(22));
j2z = b*sin(q(8)+q(26))*sin(q(23));
j3z = b*sin(q(9)+q(27))*sin(q(24));

        jx = [j1x j1y j1z;j2x j2y j2z;j3x j3y j3z];
        jq = a*b*(diag([sin(q(25))*sin(q(22)),sin(q(26))*sin(q(23)),sin(q(27))*sin(q(24))]));
        J = jq\jx;
        
%% dynamic equation
I_hat_a = ((1/3)*ma*a^2+mb*a^2)*eye(3);
M_hat_p = (mp+3*mb)*eye(3);
M_Ga = (ma/2+mb)*g*a*eye(3)*[cos(q(7)) cos(q(8)) cos(q(9))].';
F_Gp = [0 0 -(mp+3*mb)*g].';
Mq = I_hat_a+((inv(J).')*M_hat_p)/J;
Cq = (inv(J).')*M_hat_p*dinv_J;
Gq = -M_Ga-(inv(J).')*F_Gp;
Hq = Cq*q(10:12)+Gq;
%error
e = [q11;q12;q13]-q(7:9);
de = [qd_dot(1);qd_dot(2);qd_dot(3)]-q(10:12);
int_e = [q(13) q(14) q(15)].';
%% Fuzzy PD & PID
parameters =readfis('fuzzy');
P1=evalfis([e(1) de(1)],parameters);
Kp1=P1(1)*2000;
Kd1=P1(2)*100;
KI1=P1(3)*1800;

P2=evalfis([e(2) de(2)],parameters);
Kp2=P2(1)*2000;
Kd2=P2(2)*100;
KI2=P2(3)*1800;

P3=evalfis([e(3) de(3)],parameters);
Kp3=P3(1)*2000;
Kd3=P3(2)*100;
KI3=P3(3)*1800; 

Kd = diag([Kd1,Kd2,Kd3]);
Kp = diag([Kp1,Kp2,Kp3]);
KI = diag([KI1,KI2,KI3]);

aq1 = qd_2dot(1)+Kd(1,1)*de(1)+Kp(1,1)*e(1);%+KI(1,1)*int_e(1);
aq2 = qd_2dot(2)+Kd(2,2)*de(2)+Kp(2,2)*e(2);%+KI(2,2)*int_e(2);
aq3 = qd_2dot(3)+Kd(3,3)*de(3)+Kp(3,3)*e(3);%+KI(3,3)*int_e(3);
tow = Mq*[aq1;aq2;aq3]+Hq;
 if (1.14<= t) && (t<=1.16)
    tow = tow+1;
 end 
dq(40:42) = [Kp1 Kp2 Kp3].';
dq(43:45) = [Kd1 Kd2 Kd3].';
dq(46:48) = [KI1 KI2 KI3].';

%% PD & PID
% PID gain
% Kd = diag([40 40 40]);Kp = diag([1000 1000 1000]);
% KI = diag([1000,1000,1000]);
% PD gain
% Kd = diag([40 40 40]);Kp = diag([500 500 500]);
% aq1 = qd_2dot(1)+Kd(1,1)*de(1)+Kp(1,1)*e(1);%+KI(1,1)*int_e(1);
% aq2 = qd_2dot(2)+Kd(2,2)*de(2)+Kp(2,2)*e(2);%+KI(2,2)*int_e(2);
% aq3 = qd_2dot(3)+Kd(3,3)*de(3)+Kp(3,3)*e(3);%+KI(3,3)*int_e(3);
% tow = Mq*[aq1;aq2;aq3]+Hq;
%  if (1.13<= t) && (t<=1.17)
%     tow = tow+1;
%  end   
%% System states
dq(1:3) = tow;
dq(4:6) = p;
dq(7:9) = q(10:12);       %q1_1dot
q_2dot  = Mq\(-Hq+tow) ;  
dq(10:12) =  q_2dot;      %q1_2dot
dq(13:15) = e;
dq(16:18) = de;
dq(19:21) = [q11 q12 q13].';
% velocities
dq(22) = -p_dot1(2)/(b*sin(q(22))); %q31_dot
dq(23) = -p_dot2(2)/(b*sin(q(23))); %q32_dot
dq(24) = -p_dot3(2)/(b*sin(q(24))); %q33_dot
dq(25) = (-p_dot1(1)*cos(q(7))-p_dot1(3)*sin(q(7))+b*cos(q(25))*cos(q(22))*dq(22))/(b*sin(q(25))*sin(q(22)))-q(10);%q21_dot
dq(26) = (-p_dot2(1)*cos(q(8))-p_dot2(3)*sin(q(8))+b*cos(q(26))*cos(q(23))*dq(23))/(b*sin(q(26))*sin(q(23)))-q(11);%q22_dot
dq(27) = (-p_dot3(1)*cos(q(9))-p_dot3(3)*sin(q(9))+b*cos(q(27))*cos(q(24))*dq(24))/(b*sin(q(27))*sin(q(24)))-q(12);%q23_dot  
dq(28:30) = [q31 q32 q33].';
dq(31:33) = qd_dot;
dq(34:36) = qd_2dot;
dq(37:39) = p_dot1;
%% derivative of jacobian Matrix

 dj1x = b*(cos(phi(1))*(-(q(10)+dq(25))*sin(q(7)+q(25))*sin(q(22))+dq(22)*cos(q(7)+q(25))*cos(q(22))))+b*sin(phi(1))*dq(22)*sin(q(22));
 dj2x = b*(cos(phi(2))*(-(q(11)+dq(26))*sin(q(8)+q(26))*sin(q(23))+dq(23)*cos(q(8)+q(26))*cos(q(23))))+b*sin(phi(2))*dq(23)*sin(q(23));
 dj3x = b*(cos(phi(3))*(-(q(12)+dq(27))*sin(q(9)+q(27))*sin(q(24))+dq(24)*cos(q(9)+q(27))*cos(q(24))))+b*sin(phi(3))*dq(24)*sin(q(24));
 
 dj1y = b*(sin(phi(1))*(-(q(10)+dq(25))*sin(q(7)+q(25))*sin(q(22))+dq(22)*cos(q(7)+q(25))*cos(q(22))))-b*cos(phi(1))*dq(22)*sin(q(22));
 dj2y = b*(sin(phi(2))*(-(q(11)+dq(26))*sin(q(8)+q(26))*sin(q(23))+dq(23)*cos(q(8)+q(26))*cos(q(23))))-b*cos(phi(2))*dq(23)*sin(q(23));
 dj3y = b*(sin(phi(3))*(-(q(12)+dq(27))*sin(q(9)+q(27))*sin(q(24))+dq(24)*cos(q(9)+q(27))*cos(q(24))))-b*cos(phi(3))*dq(24)*sin(q(24));
 
 dj1z = b*((q(10)+dq(25))*cos(q(7)+q(25))*sin(q(22))+dq(22)*sin(q(7)+q(25))*cos(q(22)));
 dj2z = b*((q(11)+dq(26))*cos(q(8)+q(26))*sin(q(23))+dq(23)*sin(q(8)+q(26))*cos(q(23)));
 dj3z = b*((q(12)+dq(27))*cos(q(9)+q(27))*sin(q(24))+dq(24)*sin(q(9)+q(27))*cos(q(24)));
 

 
        djx = [dj1x dj1y dj1z;dj2x dj2y dj2z;dj3x dj3y dj3z];
        djq = a*b*diag([dq(25)*cos(q(25))*sin(q(22))+dq(22)*sin(q(25))*cos(q(22)),...
            dq(26)*cos(q(26))*sin(q(23))+dq(23)*sin(q(26))*cos(q(23)),...
            dq(27)*cos(q(27))*sin(q(24))+dq(24)*sin(q(27))*cos(q(24))]);
              dinv_J = inv(J)*inv(jq)*(djq-djx/J);
          
 end             
